%global _internal_version  f9e5c51
%define date 20170106
# .so name pulls in a lot of devel packages
%global __requires_exclude_from ^%{_libdir}/.*\\.so$

Name:           cinnamon
Version:        3.2.8
%define subrel	1
Release:        %mkrel 4
#Release:        %mkrel 0.%{date}.git%{_internal_version}
Summary:        Window management and application launching for Cinnamon

Group:          Graphical desktop/Cinnamon
# cinnamon-menu-editor is LGPLv2+
License:        GPLv2+ and LGPLv2+
URL:            http://cinnamon.linuxmint.com
# To generate tarball

Source0:        %{name}-%{version}.tar.gz
#SourceGet0: https://github.com/linuxmint/Cinnamon/archive/%{version}.tar.gz

#Source0:        %{name}-%{version}.git%{_internal_version}.tar.gz
##SourceGet0: https://github.com/linuxmint/Cinnamon/tarball/%{_internal_version}
Source1:        cinnamon-mageia.gschema.override
Source3:        polkit-cinnamon-authentication-agent-1.desktop
# fix power applet using version by robin92
# https://github.com/linuxmint/Cinnamon/issues/3068
#Source7:        power-applet.js
Source4:        mageia-menu.svg

# from fedora
Patch0:         background.patch
Patch1:         autostart.patch
Patch2:         default_panal_launcher.patch

Patch3:		cinnamon-settings-fix-symlink-vuln.patch

%global clutter_version 1.12.2
%global gobject_introspection_version 0.10.1
%global muffin_version 2.6.2
%global eds_version 2.91.6
%global json_glib_version 0.13.2
%global polkit_version 0.100

BuildRequires:  pkgconfig(clutter-x11-1.0) >= %{clutter_version}
BuildRequires:  pkgconfig(dbus-glib-1)
BuildRequires:  desktop-file-utils
BuildRequires:  glib2-devel
BuildRequires:  pkgconfig(gconf-2.0)
BuildRequires:  pkgconfig(gobject-introspection-1.0) >= %{gobject_introspection_version}
BuildRequires:  pkgconfig(json-glib-1.0) >= %{json_glib_version}
BuildRequires:  pkgconfig(libnm-glib)
BuildRequires:  pkgconfig(libnm-util)
BuildRequires:  pkgconfig(polkit-agent-1) >= %{polkit_version}
BuildRequires:  libgudev-devel
# for screencast recorder functionality
BuildRequires:  pkgconfig(gstreamer-1.0)
BuildRequires:  pkgconfig(gtk+-3.0)
BuildRequires:  intltool
BuildRequires:  pkgconfig(libcanberra)
BuildRequires:  pkgconfig(libcroco-0.6) >= 0.6.2
BuildRequires:  pkgconfig(gnome-keyring-1)
BuildRequires:  pkgconfig(libsoup-2.4)
BuildRequires:  pkgconfig(libnm-glib-vpn)
BuildRequires:  pkgconfig(libstartup-notification-1.0)

# for barriers
BuildRequires:  pkgconfig(xfixes) >= 5.0
# used in unused BigThemeImage
BuildRequires:  librsvg2-devel
BuildRequires:  pkgconfig(libmuffin) >= %{muffin_version}
BuildRequires:  libpulseaudio-devel
# Bootstrap requirements
BuildRequires: gtk-doc 
BuildRequires: gnome-common
%ifnarch %{arm}
BuildRequires:  pkgconfig(libwacom)
BuildRequires:  pkgconfig(xorg-wacom)
%endif
BuildRequires:  pkgconfig(xtst)
BuildRequires:  pkgconfig(gio-2.0)
BuildRequires:  pkgconfig(gio-unix-2.0)
BuildRequires:  pkgconfig(libxml-2.0)
BuildRequires:  pkgconfig(gdk-x11-3.0)
BuildRequires:  pkgconfig(cjs-internals-1.0)
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(cinnamon-desktop) >= 2.0.4
BuildRequires:  pkgconfig(libcinnamon-menu-3.0)

#required for applet fix
BuildRequires:  patchelf
BuildRequires:  chrpath

Requires:       cinnamon-menus
# wrapper script uses to restart old GNOME session if run --replace
# from the command line
Requires:       gobject-introspection >= %{gobject_introspection_version}
# needed for loading SVG's via gdk-pixbuf
#Requires:       librsvg2%{?_isa}
# needed as it is now split from Clutter
Requires:       json-glib >= %{json_glib_version}
# might be still be needed.
Requires:       muffin >= %{muffin_version}
# Get upower 1.0 api changes
Requires:       upower >= 0.99.0
Requires:       polkit >= 0.100
# needed for session files
# cinnamon-session version fixes location of helper app
Requires:       cinnamon-session
# needed for schemas
Requires:       at-spi2-atk
# needed for on-screen keyboard
Requires:       caribou
# needed for settings
Requires:       python-gobject
Requires:       python-gobject-cairo
Requires:       dbus-python
Requires:       python-lxml
Requires:       gnome-python-gconf
Requires:       python-imaging
Requires:       python-pam
Requires:       python-pexpect
Requires:       python-pillow
Requires:       cinnamon-control-center
Requires:       cinnamon-screensaver
Requires:       cinnamon-translations
# fix 10916
Requires:       gnome-themes-standard
# fix cinnamon startup crashes
Requires:       typelib(fontconfig)
# include cjs introspection
Requires:       cjs
# Mate polkit
Requires:       mate-polkit
# requires for keyboard applet
Requires:       gucharmap

# required for network applet
Requires:       networkmanager-applet
#needed for cinnamon-looking-glass
Requires:       python-pyinotify
#needed for cinnamon-json-makepot
Requires:       python-polib
# needed for user and groups and things that need root
# see bug 17691
Requires:       gksu-polkit

#otherwise crashed at login
Requires:       nemo

# cinnamon handles notifications natively, no notification-daemon needed
Provides:       virtual-notification-daemon
# and ditto for polkit authorisation dialogs
Provides:       polkit-agent

#force requires to deal with mutter confusion

Requires:  %{mklibname clutter-gir 1.0}
Requires:  %{mklibname cogl-pango-gir 1.0}
Requires:  %{mklibname cogl-gir 1.0}

%description
Cinnamon is a Linux desktop which provides advanced
 innovative features and a traditional user experience.

The desktop layout is similar to Gnome 2. 
The underlying technology is forked from Gnome Shell.
The emphasis is put on making users feel at home and providing
 them with an easy to use and comfortable desktop experience.

%package   devel-doc
Summary:   Development Documentation files for Cinnamon
BuildArch: noarch
Requires:  %{name} = %{version}-%{release}

%description	   devel-doc
This package contains the code documentation for various Cinnamon components.

%prep
%autosetup -p1 -n Cinnamon-%{version}
#autosetup -p1 -n linuxmint-Cinnamon-%{_internal_version}

# remove gschema
rm -rf data/org.cinnamon.gschema.xml

# have cinnamon use mageia app system
grep -r -l cinnamon-applications.menu files%{_datadir} files%{_bindir}  src | \
xargs sed -i -e 's@cinnamon-applications@applications@g' 

# files replaced with mageia files
rm -rf files%{_sysconfdir}/xdg
rm -f files%{_datadir}/desktop-directories/cinnamon-{menu-applications,utility,utility-accessibility,development,education,game,graphics,network,audio-video,office,system-tools,other}.directory

# replace icon 
sed -i ./files/usr/share/cinnamon/applets/menu@cinnamon.org/settings-schema.json -e s@menu-symbolic.svg@mageia-menu.svg@g
sed -i ./files/usr/share/cinnamon/applets/menu@cinnamon.org/applet.js -e s@menu-symbolic.svg@mageia-menu.svg@g

rm -f configure
rm -rf debian/

NOCONFIGURE=1 ./autogen.sh

%build
%configure2_5x \
 --disable-static \
 --disable-rpath \
 --disable-schemas-compile \
 --enable-introspection=yes \
 --enable-compile-warnings=no

sed -i -e 's! -shared ! -Wl,--as-needed\0!g' libtool

%make V=1

%install
%makeinstall_std
find %{buildroot} -type f -name "*.la" -delete -print

install -D -m 0644 %{SOURCE1} %{buildroot}%{_datadir}/glib-2.0/schemas/cinnamon-mageia.gschema.override

# install polkik autostart desktop file
install -D -p -m 0644 %{SOURCE3} %{buildroot}%{_datadir}/applications/
install -D -p -m 0644 %{SOURCE4} %{buildroot}%{_datadir}/cinnamon/theme

desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon2d.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon-killer-daemon.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon-settings*.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon-menu-editor.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/polkit-cinnamon-authentication-agent-1.desktop

desktop-file-install                                 \
 --add-category="Utility"                            \
 --remove-category="DesktopSettings"                 \
 --remove-key="Encoding"                             \
 --add-only-show-in="GNOME"                          \
 --delete-original                                   \
 --dir=%{buildroot}%{_datadir}/applications       \
 %{buildroot}%{_datadir}/applications/*

# fix path for CinnamonJS
ln -s cinnamon/libcinnamon-js.so %{buildroot}%{_libdir}

# fix hard coded paths
%ifarch x86_64 ppc64
sed -i -e 's@/usr/lib/cinnamon-control-center@/usr/lib64/cinnamon-control-center@g' \
$RPM_BUILD_ROOT/%{_prefix}/share/cinnamon/cinnamon-settings/bin/capi.py
%endif

# delete the preload bits till it supports systemd
rm -f $RPM_BUILD_ROOT/%{_bindir}/cinnamon-preload*
rm -rf $RPM_BUILD_ROOT/%{_sysconfdir}/cinnamon/

%posttrans
if [ "$1" -eq 1 ]; then
	if [ -e %{_datadir}/xsessions/10Cinnamon.desktop ]; then
		rm -rf %{_datadir}/xsessions/10Cinnamon.desktop
	fi
	if [ -e %{_datadir}/xsessions/11Cinnamon2D.desktop ]; then
		rm -rf %{_datadir}/xsessions/11Cinnamon2D.desktop
	fi
fi

%files
%doc README AUTHORS
%license COPYING
%{_bindir}/*
%{_datadir}/desktop-directories/cinnamon-*.directory
%{_datadir}/glib-2.0/schemas/*
%{_datadir}/applications/*
%{_datadir}/icons/hicolor/*/*/bluetooth.svg
%{_datadir}/icons/hicolor/*/*/cs-*.svg
%{_datadir}/icons/hicolor/*/*/pan-*.svg
%{_datadir}/icons/hicolor/*/*/audio-*.svg
%{_datadir}/icons/hicolor/*/*/*-lock-*.svg
%{_datadir}/icons/hicolor/*/*/cpu-*.svg
%{_datadir}/icons/hicolor/*/*/cinnamon-panel-launcher.svg
%{_datadir}/polkit-1/actions/org.cinnamon.settings-users.policy
%{_datadir}/cinnamon/
%{_datadir}/cinnamon-*/
%{_datadir}/dbus-1/services/org.Cinnamon.*.service
%{_datadir}/xsessions/*
%{_libdir}/cinnamon/
%{_libdir}/libcinnamon-js.so
%{_libexecdir}/cinnamon/
%{_mandir}/man1/*.1.*

%files devel-doc
%doc %{_datadir}/gtk-doc/html/*/


%changelog
* Sun Feb 03 2019 luigiwalser <luigiwalser> 3.2.8-4.1.mga6
+ Revision: 1362754
- rediff patch from opensuse to fix CVE-2018-13054

* Sat Mar 25 2017 joequant <joequant> 3.2.8-4.mga6
+ Revision: 1094831
- add back panel launcher patch

* Mon Mar 06 2017 eatdirt <eatdirt> 3.2.8-3.mga6
+ Revision: 1089092
- Fix missing Requires to nemo

* Wed Mar 01 2017 ghibo <ghibo> 3.2.8-2.mga6
+ Revision: 1088282
- Rebuilt against pulseaudio 10

* Mon Jan 23 2017 joequant <joequant> 3.2.8-1.mga6
+ Revision: 1083164
- upgrade to 3.2.8

* Sun Nov 27 2016 joequant <joequant> 3.0.7-5.mga6
+ Revision: 1070411
- fix requires

* Sun Nov 27 2016 joequant <joequant> 3.0.7-4.mga6
+ Revision: 1070391
- fix requires

* Thu Nov 24 2016 joequant <joequant> 3.0.7-3.mga6
+ Revision: 1069559
- add typelibs which are needed to pick up some required typelibs

* Sun Oct 02 2016 pterjan <pterjan> 3.0.7-2.mga6
+ Revision: 1058159
- patchelf now works on arm

* Fri Aug 26 2016 joequant <joequant> 3.0.7-1.mga6
+ Revision: 1048991
- Update to 3.0.7 to fix #19250

* Fri Jun 03 2016 joequant <joequant> 3.0.3-3.mga6
+ Revision: 1020077
- Bug #18147 - No logout buttons on session close

* Mon May 30 2016 joequant <joequant> 3.0.3-2.mga6
+ Revision: 1019386
- Bug 18579 - add mageia icon to cinnamon

* Sat May 21 2016 joequant <joequant> 3.0.3-1.mga6
+ Revision: 1017343
- upgrade to 3.0.3

* Tue May 03 2016 joequant <joequant> 3.0.1-1.mga6
+ Revision: 1008831
- upgrade to 3.0.1

* Sun May 01 2016 wally <wally> 2.8.7-3.mga6
+ Revision: 1008449
- drop wmsession.d configs and rely on xsession files from upstream

* Sun May 01 2016 joequant <joequant> 2.8.7-2.mga6
+ Revision: 1008395
- fix 17961 - need gksu-polkit for user and groups

* Sat Mar 26 2016 joequant <joequant> 2.8.7-1.mga6
+ Revision: 995550
- upgrade to 2.8.7

* Mon Feb 22 2016 joequant <joequant> 2.8.6-1.mga6
+ Revision: 976118
- upgrade to 2.8.6 and fix link to gnome-terminal

* Sat Feb 13 2016 umeabot <umeabot> 2.8.4-4.mga6
+ Revision: 959706
- Mageia 6 Mass Rebuild

* Thu Nov 19 2015 neoclust <neoclust> 2.8.4-3.mga6
+ Revision: 904124
- patchelf is not available on arm

* Wed Nov 18 2015 joequant <joequant> 2.8.4-1.mga6
+ Revision: 903999
- upgrade to 2.8.4

* Thu Oct 22 2015 joequant <joequant> 2.8.0-2.mga6
+ Revision: 894098
- fix capi.py

* Wed Oct 21 2015 joequant <joequant> 2.8.0-1.mga6
+ Revision: 893695
- upgrade to 2.8.0

* Sun Aug 09 2015 joequant <joequant> 2.6.9-3.mga6
+ Revision: 862299
- change excludes to be .so based

* Sun Aug 09 2015 joequant <joequant> 2.6.9-2.mga6
+ Revision: 862087
- remove devel from requires

* Fri Jun 26 2015 joequant <joequant> 2.6.9-1.mga6
+ Revision: 844331
- change muffin dependency
- upgrade to 2.6

* Tue Jun 23 2015 joequant <joequant> 2.4.5-3.mga6
+ Revision: 840993
- rebuild with Adwaita fix
- Fix errata with bad capitalization for Adwaita

* Tue May 05 2015 joequant <joequant> 2.4.5-2.mga5
+ Revision: 821258
- fix override to use Adwaita by default

* Thu Nov 27 2014 joequant <joequant> 2.4.5-1.mga5
+ Revision: 799529
- update to 2.4.5
- update to 2.4.4

* Sun Nov 23 2014 joequant <joequant> 2.4.3-1.mga5
+ Revision: 798490
- add chrpath
- update to 2.4
- update to 2.4

* Wed Oct 15 2014 umeabot <umeabot> 2.2.16-6.mga5
+ Revision: 748794
- Second Mageia 5 Mass Rebuild

* Thu Sep 18 2014 umeabot <umeabot> 2.2.16-5.mga5
+ Revision: 693607
- Rebuild to fix library dependencies

* Tue Sep 16 2014 umeabot <umeabot> 2.2.16-4.mga5
+ Revision: 678395
- Mageia 5 Mass Rebuild

* Sat Aug 30 2014 joequant <joequant> 2.2.16-3.mga5
+ Revision: 669356
- add another icon patch

* Fri Aug 29 2014 joequant <joequant> 2.2.16-2.mga5
+ Revision: 669262
- use adwaita icon names

* Mon Aug 25 2014 joequant <joequant> 2.2.16-1.mga5
+ Revision: 667275
- update to 2.2.16

* Sun Jul 06 2014 joequant <joequant> 2.2.13-3.mga5
+ Revision: 644202
- put in power-applet workaround

* Tue Jun 10 2014 joequant <joequant> 2.2.13-2.mga5
+ Revision: 635402
- rebuild with new cinnamon stack

* Mon Jun 09 2014 joequant <joequant> 2.2.13-1.mga5
+ Revision: 635277
- upgrade to 2.2.13

* Tue May 20 2014 joequant <joequant> 2.2.9-2.mga5
+ Revision: 624237
- bump up rev
- add requires for cinnamon aux utilities

* Wed May 14 2014 joequant <joequant> 2.2.9-1.mga5
+ Revision: 622767
- upgrade to 2.2.9 - fix broken sound applets

* Sat Apr 19 2014 joequant <joequant> 2.2.3-1.mga5
+ Revision: 616967
- upgrade to 2.2

* Thu Apr 17 2014 joequant <joequant> 2.0.14-13.mga5
+ Revision: 615450
- bump version
- remove nautilus dependency

* Mon Mar 31 2014 joequant <joequant> 2.0.14-12.mga5
+ Revision: 610755
- remove bluetooth to sync with fedora patches
- rebuild to remove bluetooth applet dependency

* Fri Mar 14 2014 joequant <joequant> 2.0.14-11.mga5
+ Revision: 603474
- fix cinnamon menus
- revert previous menu fix changes.  Too much disruption of directory structure

* Thu Mar 06 2014 joequant <joequant> 2.0.14-9.mga5
+ Revision: 600456
- fix missing time for upower 1.0

* Mon Feb 24 2014 pterjan <pterjan> 2.0.14-8.mga5
+ Revision: 596126
- Rebuild for new cogl
+ joequant <joequant>
- use standard cinnamon locations to fix menu issues

* Fri Feb 07 2014 joequant <joequant> 2.0.14-6.mga5
+ Revision: 585035
- add fedora compile fix
+ neoclust <neoclust>
- Rebuild against new libcogl-pango

* Fri Jan 24 2014 colin <colin> 2.0.14-5.mga4
+ Revision: 567692
- Prevent duplicate Cinnamon sessions in (at least) GDM mga#11582

* Wed Jan 08 2014 joequant <joequant> 2.0.14-4.mga4
+ Revision: 565561
- push to core/release

* Fri Jan 03 2014 joequant <joequant> 2.0.14-3.mga4
+ Revision: 564206
- add 11567

* Fri Jan 03 2014 joequant <joequant> 2.0.14-2.mga4
+ Revision: 564154
- add MCC to panel - fixes 11834
- pull over fedora authentication patches

* Wed Jan 01 2014 joequant <joequant> 2.0.14-1.mga4
+ Revision: 563792
- upgrade to 2.0.14

* Sun Dec 22 2013 joequant <joequant> 2.0.4-2.mga4
+ Revision: 559926
- add provides for polkit and virtual-notification-daemon

* Wed Oct 23 2013 joequant <joequant> 2.0.4-1.mga4
+ Revision: 546391
- upgrade to 2.0.4

* Tue Oct 22 2013 umeabot <umeabot> 2.0.2-3.mga4
+ Revision: 545330
- Mageia 4 Mass Rebuild

* Mon Oct 14 2013 joequant <joequant> 2.0.2-2.mga4
+ Revision: 496782
- point setup tool to the right directory in cinnamon-control-center

* Fri Oct 11 2013 joequant <joequant> 2.0.2-1.mga4
+ Revision: 495421
- update to 2.0.2

* Tue Oct 01 2013 joequant <joequant> 1.9.2-1.mga4
+ Revision: 490051
- repack source files
- add source package
- update to 1.9.2

* Thu Sep 19 2013 joequant <joequant> 1.9.2-0.20130918git8a53cfb.1.mga4
+ Revision: 481357
- update git

* Mon Sep 09 2013 joequant <joequant> 1.9.2-0.6.gitae09c76.mga4
+ Revision: 476700
- set to mageia defaults
  add backgrounds
- fix background patch to add more dirs

* Mon Sep 02 2013 joequant <joequant> 1.9.2-0.4.gitae09c76.mga4
+ Revision: 474263
- update cinnamon

* Sun Aug 25 2013 joequant <joequant> 1.9.2-0.3.git8bdd61f.mga4
+ Revision: 471493
- add requires to cinnamon-settings

* Sun Aug 25 2013 joequant <joequant> 1.9.2-0.2.git8bdd61f.mga4
+ Revision: 471459
- add cjs require

* Sat Aug 24 2013 joequant <joequant> 1.9.2-0.1.git8bdd61f.mga4
+ Revision: 470787
- buildrequires
- build requires fixes
- build requires
- upgrade cinnamon

* Wed Aug 21 2013 joequant <joequant> 1.9.1-6.mga4
+ Revision: 468766
- add fontconfig requires

* Sun Aug 04 2013 joequant <joequant> 1.9.1-5.mga4
+ Revision: 463379
- fix 10916 - change 2d startup file

* Sun Aug 04 2013 joequant <joequant> 1.9.1-4.mga4
+ Revision: 463340
- add requires to fix 10916

* Thu Aug 01 2013 malo <malo> 1.9.1-3.mga4
+ Revision: 462350
- rebuild for new cogl

* Tue Jul 30 2013 joequant <joequant> 1.9.1-2.mga4
+ Revision: 460897
- rebuild cinnamon for new mozjs

* Fri Jun 28 2013 joequant <joequant> 1.9.1-1.mga4
+ Revision: 448000
- update to 1.9.1
- fix settings and themes
- update to 1.8.7
  clean up spec file
- update to 1.8.6 + gnome 3.8 patches
- remove gnome-panel which no longer exists in 3.8
- upgrade cinnamon and muffin
- add cinnamon-launcher
- update to 1.7.8
- sync to latest 1.7 versions of cinnamon
- update to 1.7.1
- sync up with current trunk
- change location of helper app to reflect gnome-session change
- grab new speedup patch from github mtwebster/Cinnamon:menu-again
- remove typelib(Meta) symbol from requires
- change cinnamon to use muffin API tag
  remove fedora patches
  speed up menu
- modify to match mageia path locations
- switch back to running under gnome-session
- use cinnamon startup instead of gnome-session
- imported package cinnamon


* Sat Jul 14 2012 Pedro <simplew8@gmail.com> 1.4.0-1
- first package (from git master revision 06c765e..9213641)
- avoid treating warnings as errors
